class LoginState extends RootState{
    constructor(){
        super();
    }
    init(){
        this.mainInit();
    }
    preload() {
        ///Необходимые для запуска меню авторизации ассеты
        this.load.image('bg_2','assetes/img/gui/bg/bg_2.png');
        this.load.image('column','assetes/img/gui/ui/column.png');
        //this.load.image('ui_2','assetes/img/gui/ui/ui_2.png');
        this.load.image('ui_5','assetes/img/gui/ui/ui_5.png');
        this.load.image('label','assetes/img/gui/ui/label.png');
        this.load.spritesheet('fire','assetes/img/gui/ui/fire.png',100,200);
        this.load.spritesheet('flags','assetes/img/gui/ui/flags.png',50,25);
        this.load.spritesheet('button_close','assetes/img/gui/buttons/button_close.png',60,60);
        //this.load.spritesheet('button_signIn','assetes/img/gui/buttons/button_signIn.png',151,57);
        //this.load.spritesheet('button_registration','assetes/img/gui/buttons/button_registration.png',151,57);
        //this.load.spritesheet('button_create','assetes/img/gui/buttons/button_create.png',151,57);
        //this.load.spritesheet('button_guest','assetes/img/gui/buttons/button_guest.png',187,71);
        //this.load.spritesheet('button_close','assetes/img/gui/buttons/button_close.png',144,132);
        this.load.spritesheet('button_empty','assetes/img/gui/buttons/button_empty.png',190,40);
        this.game.load.audio('onclick',['assetes/audio/onclick.ogg']);
        this.game.load.audio('onover',['assetes/audio/onover.ogg']);
    }
 
    create() {
        this.mainCreate();
        this.creteGUI();
        
    }
    update(){
        this.mainUpdate();
    }
    render(){
        this.mainRender();
    }
    creteGUI(){
        let ui = this.GUI.addUI(0,0,this.game.width,this.game.height,null,15,10);
        ui.addBackground(0,'bg_2',1,false);
        //let bg = ui.addCastomSizeBackground(0,1600,1200,'bg_2',1,false)
        this.createFireUi(ui);
        this.createLoginUI(ui);
        
        let textInfo = ui.addText(4,true,ui.width*0.5,ui.height - 50,ASSETS.getText('text1',LANGUAGE)+clientVersion,ASSETS.textStyles['commonString'],1,true);
        textInfo.fill = '#FF4500';
        /*
        let serverInfo = ui.addText(4,true,ui.width*0.5,ui.height*0.5-200,ASSETS.getText('text50',LANGUAGE),ASSETS.textStyles['commonBigString'],1,true);
        serverInfo.fill = '#FF0000';
        */
        
        //textInfo.anchor.setTo(0.5,0.0);  
        //sdfsd
        this.addChangeLanguageUI(ui,ui.width - 50,50);
        /*
        let flags = ui.addImage(1,true,ui.width - 50,50,50,25,'flags',1,true);
        flags.events.onInputDown.add(function(){
            if(LANGUAGE == 'en'){
                CH.setCookie('language','ru'); 
                LANGUAGE = CH.getCookie('language');
                game.state.restart();
            }else if(LANGUAGE == 'ru'){
                CH.setCookie('language','en'); 
                LANGUAGE = CH.getCookie('language');
                game.state.restart();
            }
        },this);
        ui.addUpdate(function(){
            if(LANGUAGE == 'en'){
                flags.frame = 0; 
            }else if(LANGUAGE == 'ru'){
                flags.frame = 1;
            }
        })
        */
    }
    createFireUi(ui){
        let leftColumn = ui.addImage(1,true,ui.width*0.5 - 250,ui.height*0.5 + 100,128,128,'column',1,true);
        let leftFire = ui.addImage(1,false,leftColumn.x,leftColumn.y - leftColumn.height,100,200,'fire',1,true);
        leftFire.animations.add('burn');
        leftFire.animations.play('burn', 5, true);
        let rightColumn = ui.addImage(1,true,ui.width*0.5 + 250,ui.height*0.5 + 100,128,128,'column',1,true);
        let rightFire = ui.addImage(1,true,rightColumn.x,rightColumn.y - rightColumn.height,100,200,'fire',1,true);
        rightFire.animations.add('burn');
        setTimeout(function(){
            rightFire.animations.play('burn', 5, true);
        },100);
        
    }
    
    createLoginUI(mainUI){
        var that = this; 
        let ui = mainUI.addUI(1,false,(mainUI.width*0.5) - (400/2),(mainUI.height*0.5) - (400/2),400,400,5);
        ui.addBackground(0,'ui_5',1,false);
        //let name  = ui.addText(3,true,0,0,'Сервер: '+KEEPER.serverStatus,14,1,false);
        let label = ui.addImage(1,false,mainUI.width*0.5,(mainUI.height*0.5) - (145),800/5,200/5,'label',1,true);
        ///Добавляем кнопку регистрации
        let regButton = ui.addButtonWithText(2,true,ui.width*0.7,300,150,40,'button_empty',function(){
            ///Создание окна регистации
            ui.delete();
            that.createRegistrationUI(mainUI);
            
            
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text73',LANGUAGE),ASSETS.textStyles['button'],1);
        ///Добавляем кнопку регистрации
        let guestButton = ui.addButtonWithText(2,true,ui.width*0.3,300,150,40,'button_empty',function(){
           
            HANDLER.guestRegistration();
              
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text72',LANGUAGE),ASSETS.textStyles['button'],1);
       ////добавляем фон для полей
        let logUI = ui.addUI(1,true,(ui.width*0.5) - (150/2),(ui.height*0.5 - 25) - (80/2),150,80,5);
        logUI.addBackgroundRect(0,true,true,0xFFFFFF,0x000000,2,0.2,1,false);
        ///ПОЛЕ ВВОДА ЛОГИНА
        logUI.addRect(3,true,logUI.width*0.5,logUI.height*0.3,logUI.width*0.9,25,true,true,0xA9A9A9,0x808080,2,0.5,0.5,false);
        ///Добавляем поле логина
        let loginField = logUI.addTextFieldHtml(4,true,logUI.width*0.5,logUI.height*0.3,logUI.width*0.9,25,16,ASSETS.getText('text2',LANGUAGE),10,5,'text')
       ///ПОЛЕ ВВОДА ПАРОЛЯ
        logUI.addRect(3,true,logUI.width*0.5,logUI.height*0.7,logUI.width*0.9,25,true,true,0xA9A9A9,0x808080,2,0.5,0.5,false);
        ///Добавляем поле пароля
        let passwordField = logUI.addTextFieldHtml(4,true,logUI.width*0.5,logUI.height*0.7,logUI.width*0.9,25,16,ASSETS.getText('text3',LANGUAGE),10,5,'password')
        
        let errorString  = ui.addText(3,true,ui.width*0.5,335,'',ASSETS.textStyles['commonString'],1,false);
        errorString.anchor.setTo(0.5,0);
        errorString.fill = '#FF4500';
        errorString.visible = false;
        let inputIsCorrect = true;
        let loginButton = ui.addButtonWithText(2,true,ui.width*0.5,250,150,40,'button_empty',function(){
            onLogin()
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text71',LANGUAGE),ASSETS.textStyles['button'],1);
        let enterKey = this.game.input.keyboard.addKey(Phaser.Keyboard.ENTER);
        enterKey.onDown.add(onLogin, this);
        
        function onLogin(){
            ////Если в поле логин и пароль чтото введено
            console.log('LOGIN')
            if (LOGINHANDLER.checkLoginPassword(loginField.value,passwordField.value)){
                HANDLER.sendIdentData(loginField.value,passwordField.value,'password',null,null);
                inputIsCorrect = true;
            }
            else{
                inputIsCorrect = false;
            } 
        }
        
        
        
        if(ISKONGREGATE){
           let kongregateLoginButton = ui.addButtonWithText(2,true,ui.width*0.5,350,150,40,'button_empty',function(){
            HANDLER.kongregateLogin();
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text126',LANGUAGE),ASSETS.textStyles['button'],1); 
        }
        
        
        
        
        
        
        
        ui.addUpdate(function(){
            
            /*
            name.setText('Сервер: '+KEEPER.serverStatus);
            if(KEEPER.serverStatus == 'Online')
                name.fill = '#7CFC00';
            else
                name.fill = '#FF4500';
            */
            ///Есть ли такие логин и пароль
            if(NETWORK.lastGetEventData['SC0001'] !== undefined){
                if(!NETWORK.lastGetEventData['SC0001'].authStatus){
                    errorString.visible = true;
                    errorString.setText(ASSETS.getText('text5',LANGUAGE))
                    errorString.fill = '#FF4500';
                }
            }
            ///Корректно ли введены даные
            if(!inputIsCorrect){
                errorString.visible = true;
                errorString.setText(ASSETS.getText('text6',LANGUAGE));
                errorString.fill = '#FF4500';
            }
        });
        ///Если вообще есть данные полученные на этот эвент
        return ui;
    }
  
    createRegistrationUI(mainUI){
        var that = this;
        
        ///Добавляем окно
        let ui = mainUI.addUI(2,false,(mainUI.width*0.5) - (400/2),(mainUI.height*0.5) - (400/2),400,400,5);
        ui.addBackground(0,'ui_5',1,false);
   
        ///Добавляем кнопку закрыть
        let closeButton = ui.addButton(1,true,ui.width - 50,100,60,60,'button_close',function(){
            ///Закрыть это окно
            ui.delete();
            that.createLoginUI(mainUI);
            
        },'onclick','onover',BUTTONVALUE,1);
        
       
        let text = ui.addText(1,true,ui.width*0.5,150,ASSETS.getText('text4',LANGUAGE),ASSETS.textStyles['common'],1,false);
        text.anchor.setTo(0.5,0.5);
        
       /////ПОЛЕ ЛОГИНА 
        let login  = ui.addText(1,true,ui.width*0.3,200,ASSETS.getText('text2',LANGUAGE)+':',ASSETS.textStyles['common'],1,false);
        login.anchor.setTo(0.5,0.5);
        ui.addRect(1,true,ui.width*0.5,200,ui.width*0.25,ui.width*0.05,true,true,0xA9A9A9,0x808080,2,0.5,0.5,false);
        ///Добавляем поле логина
        let loginField = ui.addTextFieldHtml(2,true,ui.width*0.5,200,ui.width*0.25,ui.width*0.05,16,ASSETS.getText('text2',LANGUAGE),10,5,'text');
        ////ПОЛЕ ПАРОЛЯ
        let pass = ui.addText(1,true,ui.width*0.3,230,ASSETS.getText('text3',LANGUAGE)+':',ASSETS.textStyles['common'],1,false);
        pass.anchor.setTo(0.5,0.5);
        ui.addRect(1,true,ui.width*0.5,230,ui.width*0.25,ui.width*0.05,true,true,0xA9A9A9,0x808080,2,0.5,0.5,false);
        ///Добавляем поле пароля
        let passwordField = ui.addTextFieldHtml(2,true,ui.width*0.5,230,ui.width*0.25,ui.width*0.05,16,ASSETS.getText('text3',LANGUAGE),10,5,'password');
        
        let errorString  = ui.addText(3,true,ui.width*0.5,ui.height*0.85,'',ASSETS.textStyles['common'],1,false);
        errorString.anchor.setTo(0.5,0.5);
        errorString.fill = '#FF4500';
        errorString.visible = false;
        let inputIsCorrect = true;
        let sended = false;
        let createButton = ui.addButtonWithText(1,true,ui.width*0.5,ui.height*0.7,190,40,'button_empty',function(){
            onRegistration()
 
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text74',LANGUAGE),ASSETS.textStyles['button'],1);
         let enterKey = this.game.input.keyboard.addKey(Phaser.Keyboard.ENTER);
        enterKey.onDown.add(onRegistration, this);
        function onRegistration(){
            ///отправляем на сервер
            ////Если в поле логин и пароль чтото введено
            if (LOGINHANDLER.checkLoginPassword(loginField.value,passwordField.value)){
                console.log(true);
                inputIsCorrect = true;
                HANDLER.sendRegistrationData(loginField.value,passwordField.value);
                sended = true;
            }
            else{
                inputIsCorrect = false;
                console.log(inputIsCorrect);
            }
        }
       
        
        
        function onAccountCreate(){
            ui.delete();
            that.onCreateAccountUI(mainUI);
        }
        
        
        ui.addUpdate(function(){
            if((NETWORK.lastGetEventData['SC0002']) && (sended)){
                if(!NETWORK.lastGetEventData['SC0002'].regStatus){
                    errorString.visible = true;
                    errorString.setText(ASSETS.getText('text7',LANGUAGE));
                    errorString.fill = '#FF4500';
                }else{
                    
                    errorString.visible = true;
                    errorString.setText(ASSETS.getText('text8',LANGUAGE));
                    errorString.fill = '#7CFC00';
                    onAccountCreate();
                    NETWORK.lastGetEventData['SC0002'].regStatus = false;
                }
            }
            ///Корректно ли введены даные
            
            if(!inputIsCorrect){
                errorString.visible = true;
                errorString.setText(ASSETS.getText('text6',LANGUAGE));
                errorString.fill = '#FF4500';
            }
        });
        
    }
    onCreateAccountUI(mainUI){
        var that = this;
        
        let ui = this.GUI.addUI(this.game.width/2 - 300,this.game.height/2 - 150,600,300,null,15,10);
        //let ui = mainUI.addUI(5,true,mainUI.width/2 - 300,mainUI.height/2 - 150,600,300,10);
        //ui.addBackground(0,'ui_600_300',1,true);
        ui.addFullWindowRect(0,0,0,this.game.width,this.game.height,true,0x000000,0.5,function(){
            ui.delete();
            //that.GUI.deleteUI(ui);
            that.createLoginUI(mainUI);
        });
        let text = ui.addText(1,true,ui.width*0.5,ui.height*0.5,ASSETS.getText('text9',LANGUAGE),ASSETS.textStyles['commonBigString'],1,false);
        let startTime = new Date();
        ui.addUpdate(function(){
            if((new Date - startTime) > 5000){
                ui.delete();
                that.createLoginUI(mainUI);
            }
        })
    }
    
}